-- **********************************************************************
-- [FireFire] Burning player with Flamethrower
-- Version: beta 1.1
-- Author: MagNuM http://www.unrealsoftware.de/profile.php?userid=11768
-- ****************************************
-- Config (Please set these in ff_fire.cfg)

-- Burn Time              (Default = 5)
ff_fire_sec = 5


-- Burn Damage            (Default = 2)
ff_fire_dmg = 2


-- Burn Message           (Default = 0)
ff_fire_shw = 0


-- Burn Info              (Default = "Burn")
ff_fire_msg = "Burn"


-- Burn Effect            (Default = 1)
ff_fire_eff = 1


-- Burn Sound Effect      (Default = "env/ff_fire/burn.ogg")
ff_fire_snd = "env/ff_fire/burn.ogg"


-- Burn Medicine          (Default = 0)
ff_fire_kit = 0


-- Burn Medicine Price    (Default = 500)
ff_fire_pri = 500


-- Burning with Molotov cocktail?        (Default = 0)
ff_fire_mol = 0


-- The frequency of burns (Default = 3)
ff_fire_int = 3


-- To slow down the player when burned?  (Default = 0)
ff_fire_dwn = 1


-- Slow speed value       (Default = -10)
ff_fire_dsp = -10



-- ****************************************

-- HAVE FUN!

-- **********************************************************************

dofile("sys/lua/ff_fire/ff_fire.cfg")

function initArray(m)
	local array = {}
	for i = 1, m do
		array[i]=0
	end
	return array
end



-- KEY CREATE
ff_fire     = initArray(32)
ff_fire_on  = initArray(32)
ff_fire_id  = initArray(32)
ff_fire_sp  = initArray(32)
ff_fire_img = initArray(32)
ff_fire_123 = initArray(32)

addhook("hit",     "firefire_hit")
addhook("die",     "firefire_die")
addhook("spawn",   "firefire_spawn")
addhook("join",    "firefire_join")
addhook("ms100",   "firefire_ms100")

if ff_fire_mol ~= 0 then
	freehook("hit",    "firefire_hit")
	addhook("hit",     "firefire_hit2")
end

if ff_fire_kit == 1 then
	addhook("say",     "firefire_say")
	addhook("sayteam", "firefire_sayteam")
end


function firefire_join(id)
	ff_fire[id]     = 0
	ff_fire_id[id]  = 0
	ff_fire_sp[id]  = 0
	ff_fire_on[id]  = -1
	ff_fire_123[id] = 0
end


function firefire_spawn(id)
	ff_fire[id]     = 0
	ff_fire_id[id]  = 0
	ff_fire_sp[id]  = 0
	ff_fire_on[id]  = -1
	ff_fire_123[id] = 0
end


function firefire_say(id,txt)
	if ff_fire_kit == 1 then
		if (txt == "!bh") or (txt == "!BH") or (txt == "!Bh") or (txt == "!bH") then
			if ff_fire[id] == 1 then
				if player(id, "money") > ff_fire_pri - 1 then
					parse("sv_sound2 "..id.." items/pickup.wav")
					parse("setmoney "..id.." "..player(id, "money") - ff_fire_pri)
					msg2(id, "255040000[FireFire] You healed burns!")
					ff_fire[id] = 0
					ff_fire_on[id] = -1
					ff_fire_123[id] = 0
					freeimage(ff_fire_img[id])
					if ff_fire_dwn == 1 then
						parse("speedmod "..id.." "..ff_fire_sp[id])
					end
				elseif player(id, "money") < ff_fire_pri + 1 then
					parse("sv_sound2 "..id.." wpn_denyselect.wav")
					msg2(id, "255040000[FireFire] You have insufficient funds!")
				end
			end
			return 1
		end
	end
end


function firefire_sayteam(id,txt)
	if ff_fire_kit == 1 then
		if (txt == "!bh") or (txt == "!BH") or (txt == "!Bh") or (txt == "!bH") then
			if ff_fire[id] == 1 then
				if player(id, "money") > ff_fire_pri - 1 then
					parse("sv_sound2 "..id.." items/pickup.wav")
					parse("setmoney "..id.." "..player(id, "money") - ff_fire_pri)
					msg2(id, "255040000[FireFire] You healed burns!")
					ff_fire[id] = 0
					ff_fire_on[id] = -1
					ff_fire_123[id] = 0
					freeimage(ff_fire_img[id])
					if ff_fire_dwn == 1 then
						parse("speedmod "..id.." "..ff_fire_sp[id])
					end
				elseif player(id, "money") < ff_fire_pri + 1 then
					parse("sv_sound2 "..id.." wpn_denyselect.wav")
					msg2(id, "255040000[FireFire] You have insufficient funds!")
				end
			end
			return 1
		end
	end
end


function firefire_ms100()
	local i
	for _, i in pairs(player(0,"table")) do
		if ff_fire[i] == 1 then
			if ff_fire_on[i] ~= -1 then
				if ff_fire_123[i] == ff_fire_int then
						if player(i,"health") <= ff_fire_dmg then
							parse("customkill "..ff_fire_id[i].." "..ff_fire_msg.." "..i)
							parse('effect "fire" '..player(i, "x")..' '..player(i, "y")..' 0 10')
							sv_sound3(player(i, "x"), player(i, "y"), "player/die"..math.random(1,3)..".wav")
							ff_fire[i] = 0
							ff_fire_on[i] = -1
							ff_fire_123[i] = 0
							freeimage(ff_fire_img[i])
						end
						ff_fire_123[i] = 0
						sv_sound3(player(i, "x"), player(i, "y"), "player/hit"..math.random(1,3)..".wav")
						if ff_fire_eff == 1 then parse('effect "flare" '..player(i, "x")..' '..player(i, "y")..' 0 0 255 40 0'); end
						parse("sethealth "..i.." "..player(i,"health") - ff_fire_dmg)
				end
				if ff_fire_on[i] == 0 then
					ff_fire[i] = 0
					ff_fire_on[i] = -1
					ff_fire_123[i] = 0
					freeimage(ff_fire_img[i])
					if ff_fire_dwn == 1 then
						parse("speedmod "..i.." "..ff_fire_sp[i])
					end
				end
				ff_fire_123[i] = ff_fire_123[i] + 1
			end
		end
		ff_fire_on[i] = ff_fire_on[i] - 1
	end
end



function firefire_hit(id,source,weapon)
	if (weapon == 46) then
		if ff_fire[id] == 0 then
			if game("sv_friendlyfire") == "0" and game("sv_gamemode") ~= "1" and player(id, "team") ~= player(source, "team") then
				firefire_burn(id,source)
				firefire_img(id)
			elseif game("sv_friendlyfire") == "1" or game("sv_gamemode") == "1" then
				firefire_burn(id,source)
				firefire_img(id)
			end
		elseif ff_fire[id] == 1 then
			if game("sv_friendlyfire") == "0" and game("sv_gamemode") ~= "1" and player(id, "team") ~= player(source, "team") then
				ff_fire[id] = 1
				ff_fire_id[id] = source
				ff_fire_on[id] = ff_fire_sec*10
			elseif game("sv_friendlyfire") == "1" or game("sv_gamemode") == "1" then
				ff_fire[id] = 1
				ff_fire_id[id] = source
				ff_fire_on[id] = ff_fire_sec*10
			end
		end
	end
end


function firefire_hit2(id,source,weapon)
	if (weapon == 46) or (weapon == 73) then
		if ff_fire[id] == 0 then
			if game("sv_friendlyfire") == "0" and game("sv_gamemode") ~= "1" and player(id, "team") ~= player(source, "team") then
				firefire_burn(id,source)
				firefire_img(id)
			elseif game("sv_friendlyfire") == "1" or game("sv_gamemode") == "1" then
				firefire_burn(id,source)
				firefire_img(id)
			end
		elseif ff_fire[id] == 1 then
			if game("sv_friendlyfire") == "0" and game("sv_gamemode") ~= "1" and player(id, "team") ~= player(source, "team") then
				ff_fire[id] = 1
				ff_fire_id[id] = source
				ff_fire_on[id] = ff_fire_sec*10
			elseif game("sv_friendlyfire") == "1" or game("sv_gamemode") == "1" then
				ff_fire[id] = 1
				ff_fire_id[id] = source
				ff_fire_on[id] = ff_fire_sec*10
			end
		end
	end
end


function firefire_die(id)
	if ff_fire[id] == 1 then
		parse('effect "fire" '..player(id, "x")..' '..player(id, "y")..' 0 10')
		ff_fire[id] = 0
		ff_fire_on[id] = -1
		ff_fire_123[id] = 0
		freeimage(ff_fire_img[id])
	end
end


function firefire_img(id)
	ff_fire_img[id] = image("gfx/sprites/fx_flare1.bmp", player(id, "x"), player(id, "y"), 200+id)
	imagealpha(ff_fire_img[id], 1.0)
	imageblend(ff_fire_img[id], 1)
	imagecolor(ff_fire_img[id], 255, 40, 0)
end


function firefire_burn(id,source)
	ff_fire[id] = 1
	ff_fire_id[id] = source
	ff_fire_sp[id] = player(id, "speedmod")
	ff_fire_on[id] = ff_fire_sec*10
	ff_fire_123[id] = 0
	sv_sound3(player(id, "x"), player(id, "y"), ff_fire_snd)
	parse('effect "fire" '..player(id, "x")..' '..player(id, "y")..' 0 10')
	if ff_fire_dwn == 1 then
		parse("speedmod "..id.." "..ff_fire_dsp)
	end
	if ff_fire_shw == 1 then
		msg2(source, "255040000[FireFire] You burned "..player(id, "name").." !!")
	end
	if ff_fire_kit == 1 then
		msg2(id, "255040000[FireFire] Say to !bh | You can heal burns! ("..ff_fire_pri.."$)")
	end
end


-- SV_SOUND3
function sv_sound3(x,y,sound)
	for _, id in pairs(player(0,"table")) do
		if x and y and sound then
			if math.sqrt((x-player(id,"x"))^2 + (y-player(id,"y"))^2) < 300 then
				parse("sv_sound2 "..id.." "..sound)
			end
		end
	end
end


